
#ifndef _H_MCL_TOKEN
#define _H_MCL_TOKEN

#include "loc.h"
typedef enum token_type_e {
    TT_IDENT,   // identifier
    TT_STR,     // "*"
    TT_CHR,     // '*'
    TT_CURLY_R, // }
    TT_CURLY_L, // {
    TT_BRACK_R, // ]
    TT_BRACK_L, // [
    TT_PAREN_R, // )
    TT_PAREN_L, // (
    TT_COLON,   // :
    TT_SEMI,    // ;
    TT_COMMA,   // ,
    TT_DOT,     // .
    TT_AMP,     // &
    TT_STAR,    // *
    TT_PLUS,    // +
    TT_DASH,    // -
    TT_FSLASH,  // /
    TT_BAR,     // |
    TT_EQ,      // =
    TT_LT,      // <
    TT_GT,      // >
} token_type_t;


typedef struct token_s {
    token_type_t type;
    char* text;
    loc_t loc;
} token_t;

char* token_to_string(token_t* tt);

#endif
