#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "cliargs.h"
#include "dyn_arr.h"
#include "token.h"
#include "tokeniser.h"

int main(int argc, char** argv) {
    cliargs_t* cliargs = parse_cliargs(argc, argv); 
    printf("Hewo world :33\n");
    printf("Output file: %s\n", cliargs->output);

    MCL_DA_FOR_IN(char*, &cliargs->input, file, {
        printf("Input file: %s\n", file);
        tokeniser_t* tokeniser = tokenise(file);
        if (!tokeniser) {
            printf("Failed to tokenise\n");
            return 1;
        }
        MCL_DA_FOR_IN(token_t, &tokeniser->tokens, token, {
            printf("%s:%zu:%zu: %s\n", 
                    token.loc.file, 
                    token.loc.line, 
                    token.loc.col, 
                    token_to_string(&token));
        });
    });
    
    

    return 0;
}
