#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "token.h"


char* token_to_string(token_t* t) {
    char* buf = {0};
    int len = 0;
    switch(t->type) {
        case TT_IDENT: 
            return t->text;
        case TT_STR: 
            len = strlen(t->text)+3;
            buf = malloc(len);
            snprintf(buf, len, "\"%s\"", t->text);
            return buf;
        case TT_CHR:
            buf = malloc(4);
            snprintf(buf, 4, "'%c\'", *t->text);
            return buf;
        case TT_CURLY_R:
            return "}";
        case TT_CURLY_L:
            return "{";
        case TT_BRACK_R:
            return "]";
        case TT_BRACK_L:
            return "[";
        case TT_PAREN_R:
            return ")";
        case TT_PAREN_L:
            return "(";
        case TT_COLON:
            return ":";
        case TT_SEMI:
            return ";";
        case TT_COMMA:
            return ",";
        case TT_DOT:
            return ".";
        case TT_AMP:
            return "&";
        case TT_STAR:
            return "*";
        case TT_PLUS:
            return "+";
        case TT_DASH:
            return "-";
        case TT_FSLASH:
            return "/";
        case TT_BAR:
            return "|";
        case TT_EQ:
            return "=";
        case TT_LT:
            return "<";
        case TT_GT:
            return ">";
    }
}
